# bridge

## Setup

- Clone the stack repo:

  ```bash
  laconic-so fetch-stack git.vdb.to/cerc-io/nitro-stack
  ```

- Clone required repositories:

  ```bash
  laconic-so --stack ~/cerc/nitro-stack/stack-orchestrator/stacks/bridge setup-repositories
  ```

- Build container images:

  ```bash
  laconic-so --stack ~/cerc/nitro-stack/stack-orchestrator/stacks/bridge build-containers
  ```

## Create a deployment

- Create a spec file

  ```bash
  laconic-so --stack ~/cerc/nitro-stack/stack-orchestrator/stacks/bridge deploy init --output bridge-spec.yml
  ```

- TODO: Edit `network` in the spec file to map container ports to host ports as required:

  ```bash
  network:
  ports:
    go-nitro:
     - 3005:3005
     - 3006:3006
     - 4006:4006
  ```

- Create deployment

  ```bash
  laconic-so --stack ~/cerc/nitro-stack/stack-orchestrator/stacks/bridge deploy create --spec-file bridge-spec.yml --deployment-dir bridge-deployment
  ```

## Configuration

- Inside the `bridge-deployment` deployment directory, open `config.env` file and set following env variables:

  ```bash
  GETH_CHAIN_ID=1212

  OPTIMISM_CHAIN_ID=42069

  # URL endpoint of the L1 chain (Example: ws://host.docker.internal:8545)
  NITRO_L1_CHAIN_URL=

  # URL endpoint of the L2 chain (Example: ws://host.docker.internal:8546)
  NITRO_L2_CHAIN_URL=

  # Private key of the account on chain that is used for funding channels
  NITRO_CHAIN_PK: ${NITRO_CHAIN_PK}

  NITRO_SC_PK: ${NITRO_SC_PK}

  # Port to be used by P2P message service for L1
  NITRO_L1_MSG_PORT=3005

  # Port to be used by P2P message service for L2
  NITRO_L2_MSG_PORT=3006

  # Port to be used by RPC server
  NITRO_RPC_PORT=4006

  NITRO_PUBLIC_P2P_HOST=127.0.0.1

  NITRO_PUBLIC_RPC_HOST=nitro-bridge
  ```

## Start the deployment

```bash
laconic-so deployment --dir bridge-deployment start
```
